//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
function isNum(n) {
   // http://stackoverflow.com/questions/18082/validate-decimal-numbers-in-javascript-isnumeric
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function toNum(d){
    // Teste si d est un nombre.
    if (isNum(d)) return +d;
    else return 0.0;
}

function sign(x) { return x < 0 ? -1 : 1; }

function round(n, d) {
   return toNum(n.toFixed(d));
}

function dms_to_deg(strDMS) {
 
   var re = [
      // ±d° m' s'' -> [dms, sign, d, m, s]
      /^\s*([+-])?\s*(?:(\d+(?:[.,]\d+)?)\s*°)?\s*(?:(\d+(?:[.,]\d+)?\s*)[′’'])?\s*(?:(\d+(?:[.,]\d+)?)\s*(?:"|″|''|’’))?\s*$/,
   
      // ±d:m:s -> [dms, sign, d, m, s]
      /^\s*([+-])?\s*(\d+(?:[.,]\d+)?)\s*(?:\:\s*(\d+(?:[.,]\d+)?)\s*(?:\s*\:\s*(\d+(?:[.,]\d+)?)\s*)?)?\s*$/
   ]; 
   
   var dms = String(strDMS).replace(",", ".").replace(/\s+/g, '')
   
   var match = null;
   for (var i = 0, N = re.length; i < N; i++) {
      if (match = re[i].exec(dms)) break;
   }
   if (match == null) return null;

   var sign = (match[1] || "+"),
          d = (match[2] || "0"),
          m = (match[3] || "0"),
          s = (match[4] || "0");
          
   var deg = toNum(d) + toNum(m)/60.0 + toNum(s)/3600.0;
   if(sign == "-") deg = -deg;
   
   return deg;
}

function deg_to_dms(deg, nb_dec) {
   nb_dec = Math.floor(toNum(nb_dec));
   if (nb_dec < 0) nb_dec = 0;
   
   var dms = (deg < 0.0 ? "-" : "");
   deg = Math.abs(deg);
   
   var d = Math.floor(deg);
   deg = (deg - d) * 60;
   var m = Math.floor(deg);
   deg = (deg - m) * 60;
   var s = round(deg, nb_dec);
   
   if (s >= 60) {
      m += s / 60;
      s %= 60;
   }
   
   if (m >= 60) {
      d += m / 60;
      m %= 60;
   }
   
   function pad(n) {
      return (n < 10) ? ("0" + n) : n;
   }
   
   dms = dms + d + "° " + pad(m) + "′ " + pad(s.toFixed(nb_dec)) + "″";
   
   return dms;
}

function geo_dms_to_deg(strGeoDMS) { 
   var strDMS = strGeoDMS,
       geo = 1;
       
   var re = /(.*)([NSEOW])\s*$/;
   var match = re.exec(strGeoDMS);
   if (match != null) {
      strDMS = match[1];
      geo = /[NE]/.test(match[2]) ? 1 : -1;
   }
   
   var deg = dms_to_deg(strDMS);
   if (deg == null) return null;
   
   return geo * deg;
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

function onAdd(name){
   ggbApplet.setTextValue("lastObjectName", name );
   if(ggbApplet.getObjectType(name) == "point"){
      setLabelNameLaTeX(name);
   }
}

function setLabelNameLaTeX(name){
   ggbApplet.setLabelStyle(name, 3); // Légende
   ggbApplet.setLabelVisible(name, true);
   var setCaptionCmd = "SetCaption[" + name + ", \"$%n$\"]";
   ggbApplet.evalCommand(setCaptionCmd);
}

function printAuthor() {
   ggbApplet.evalCommand(
      'txtAuthor=Text["\\scriptsize \\text{\\rm\\textcolor{gray}{Patrice\\ Tremblay\\\\0x5054}}", Corner[4] + (0.1, -0.1), false, true]'
   );

   ggbApplet.setFixed("txtAuthor", true, false);
   ggbApplet.setAuxiliary("txtAuthor", true);
   ggbApplet.setLayer("txtAuthor", 0);
}

function ggbOnInit(){
   ggbApplet.registerAddListener("onAdd");
   printAuthor();
}
